'This script has been generated by PowerPCB's VB Script Wizard 
'Modified to include Via/Pin Nail Dia. Attribute (DFT.Nail Diameter) -if this attribute
' is not assigned to a testpoint, the default eg. 100 is assumed -report shows N/A.
'Searches database for all testpoints and reports their parameters to Excel.
'Script ends by selecting all testpoints -in PPCB, use Edit/Attributes/Selected to edit dia. values.
'Edited by: Ron Olinyk, Mindlink Technologies, rolinyk@execulink.com 07-05-01

'Array of column names.
Const Columns = Array("Net", "Pin/Via", "Type (Pin/Via)", "Position X", "Position Y", "Side", "Nail Size")
Dim fname As String

Sub Main
     ActiveDocument.SelectObjects(,,False)  
	fname = ActiveDocument
	If fname = "" Then
		fname = "Untitled"
	End If
	tempFile = DefaultFilePath & "\temp.txt"
	Open tempFile For Output As #1

	StatusBarText = "Generating report..."
	'Output table header
	For i = 0 to UBound(Columns)
		OutCell Columns(i)
	Next
	Print #1
	'Output table rows
	For Each tPnt in GetTestPoints(ActiveDocument,True)
		OutCell ObjName(tPnt.Net)
		OutCell GetTPName(tPnt)
		OutCell IIf (tPnt.ObjectType = ppcbObjectTypePin, "Pin", "Via")
		OutCell Format(tPnt.PositionX, "0.000")
		OutCell Format(tPnt.PositionY, "0.000")
		OutCell IIf (tPnt.TestPoint = ppcbTestPointTopLayer, "Top", "Bottom")
		OutCell ViaNail(tPnt)

		Print #1
	Next tPnt

	StatusBarText = ""
	Close #1
	ExportToExcel
		
End Sub

'Returns test point's name
Function GetTPName(tp As Object) As String
	If tp.ObjectType = ppcbObjectTypePin Then
		GetTPName = tp.Name
	Else
		GetTPName = tp.type
	End If
End Function

'Returns collection of test points in the given object
Function GetTestPoints(doc As Object, Optional Sorted As Boolean = False)
	Set GetTestPoints = doc.GetObjects(0)
	Set nets = doc.Nets
	If Sorted Then nets.Sort
	For Each aNet In nets
		Set pins = aNet.Pins
		If Sorted Then pins.Sort
		For Each aPin In pins
			If aPin.TestPoint <> ppcbTestPointNone Then
				GetTestPoints.Add aPin
			End If
		Next
		Set vias = aNet.Vias
		If Sorted Then vias.Sort
		For Each aVia In vias
			If aVia.TestPoint <> ppcbTestPointNone Then
				GetTestPoints.Add aVia
			End If
		Next
	Next

	Set pins = doc.Pins
	If Sorted Then pins.Sort
	For Each aPin In pins
		If aPin.Net Is Nothing And aPin.TestPoint <> ppcbTestPointNone Then
			GetTestPoints.Add aPin
		End If
	Next
	Set vias = doc.Vias
	If Sorted Then vias.Sort
	For Each aVia In vias
		If aVia.Net Is Nothing And aVia.TestPoint <> ppcbTestPointNone Then
			GetTestPoints.Add aVia
		End If
	Next
	GetTestPoints.Select 
End Function

Function ViaNail (attr As Object)
   On Error GoTo No_Nail_Attr
   ViaNail = attr.Attributes.Item("DFT.Nail Diameter").value
   Exit Function 
No_Nail_Attr:
ViaNail = "N/A"
   
End Function

Function ObjName (obj As Object)
	ObjName = IIf(obj Is Nothing, "", obj)
End Function


Sub ExportToExcel
	FillClipboard
	Dim xl As Object
	On Error Resume Next
	Set xl =  GetObject(,"Excel.Application")
	On Error GoTo ExcelError	' Enable error trapping.
	If xl Is Nothing Then
		Set xl =  CreateObject("Excel.Application")
	End If
	xl.Visible = True
	xl.Workbooks.Add
	xl.ActiveSheet.Paste
	xl.Range("A1:G1").Font.Bold = True
	xl.Range("A1:G1").NumberFormat = "@"
	'xl.Range("A1:G1").AutoFilter
	xl.ActiveSheet.UsedRange.Columns.AutoFit
	'Output Report Header
	xl.Rows(1).Insert
	xl.Rows(1).Cells(1) = Space(1) & "Test Point Report for " & fname & " on " & Now
	xl.Rows(2).Insert
	xl.Rows(1).Font.bold = True
	xl.Range("A1").Select
	On Error GoTo 0 ' Disable error trapping. 
	Exit Sub    

ExcelError:
	MsgBox Err.Description, vbExclamation, "Error Running Excel"
	On Error GoTo 0 ' Disable error trapping.    
	Exit Sub
End Sub

Sub OutCell (txt As String)
	Print #1, txt; vbTab;
End Sub

Sub FillClipboard
	StatusBarText = "Export Data To Clipboard..."
	' Load whole file to string variable    
	tempFile = DefaultFilePath & "\temp.txt"
	Open tempFile  For Input As #1
	L = LOF(1)
	AllData$ = Input$(L,1)
	Close #1
	'Copy whole data to clipboard
	Clipboard AllData$ 
	Kill tempFile
	StatusBarText = ""
End Sub
